/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 22/10/22.
// FIXME HACKY IMPLEMENTATION DETAIL BECAUSE THE ASSET LOADING PIPELINE IS BAD
//

#include "fggl/mesh/mesh.hpp"

#ifndef FGGL_MESH_COMPONENTS_HPP
#define FGGL_MESH_COMPONENTS_HPP

namespace fggl::mesh {

	struct StaticMesh3D {
		constexpr static const char name[] = "StaticMesh3D";
		constexpr static const util::GUID guid = util::make_guid(name);

		util::GUID meshReference;
		Mesh3D mesh;
		std::string pipeline;

		inline StaticMesh3D() = default;
		inline StaticMesh3D(const Mesh3D &aMesh, std::string aPipeline) :
			mesh(aMesh), pipeline(std::move(aPipeline)) {}
	};

	struct StaticMultiMesh3D {
		constexpr static const char name[] = "StaticMultiMesh3D";
		constexpr static const util::GUID guid = util::make_guid(name);

		util::GUID meshReference;
		MultiMesh3D mesh;
		std::string pipeline;

		inline StaticMultiMesh3D() = default;
		inline StaticMultiMesh3D(const MultiMesh3D &aMesh, std::string aPipeline) :
			mesh(aMesh), pipeline(std::move(aPipeline)) {}
	};

}

#endif //FGGL_MESH_COMPONENTS// _HPP
